## tahoe-0.6.0.tar.gz

=== Makefile ===

# this Makefile requires GNU make

# If you get an error message like the following:

# error: Setup script exited with error: Python was built with version 7.1 of Visual Studio, and extensions need to be built with the same version of the compiler, but it isn't installed.

# Then that probably means that you aren't using the the right
# compiler.  In that case, try creating distutils configuration file
# (as described in http://docs.python.org/inst/config-syntax.html ),
# specifying which compiler to use.  For example, if you use either
# the cygwin gcc compiler with mingw support, or the MINGW compiler,
# then you can add the following lines to your .cfg file:
# [build]
# compiler=mingw32

default: build

PYTHON=python
PATHSEP=$(shell python -c 'import os ; print os.pathsep')
OSSEP=$(shell python -c 'import os ; print os.sep')
TRIALPATH=$(shell which trial.py 2>/dev/null)
ifeq ($(TRIALPATH),)
TRIALPATH=$(shell which trial 2>/dev/null)
endif
ifeq ($(TRIALPATH),)
TRIALPATH=$(shell $(PYTHON) -c "import os, sys; print repr(os.path.join(sys.prefix, \"Scripts\", \"trial.py\"))")
endif
ifeq ($(TRIALPATH),)
TRIALPATH=$(shell $(PYTHON) -c "import os, sys; print repr(os.path.join(sys.prefix, \"Scripts\", \"trial\"))")
endif

REACTOR=

PLAT = $(strip $(shell python -c "import sys ; print sys.platform"))
ifeq ($(PLAT),win32)
 # The platform is Windows with cygwin build tools and the native Python interpreter.
 TRIALPATH := $(shell cygpath -w $(TRIALPATH))
 SUPPORT = $(shell cygpath -w $(shell pwd))\support
 SUPPORTLIB := $(SUPPORT)\Lib\site-packages
 SRCPATH := $(shell cygpath -w $(shell pwd))\src
 CHECK_PYWIN32_DEP := check-pywin32-dep
else
 PYVER=$(shell $(PYTHON) misc/pyver.py)
 SUPPORT = $(shell pwd)/support
 SUPPORTLIB = $(SUPPORT)/lib/$(PYVER)/site-packages
 SRCPATH := $(shell pwd)/src
 CHECK_PYWIN32_DEP := 
endif

ifeq ($(PLAT),cygwin)
REACTOR = poll
endif

ifneq ($(REACTOR),)
	REACTOROPT := --reactor=$(REACTOR)
else
	REACTOROPT := 
endif

TRIAL=$(PYTHON) -u "$(TRIALPATH)" --rterrors $(REACTOROPT)

# build-deps wants setuptools to have been built first. It's easiest to
# accomplish this by depending upon the tahoe compile.
build-deps: .built check-twisted-dep
	mkdir -p "$(SUPPORTLIB)"
	PYTHONPATH="$(PYTHONPATH)$(PATHSEP)$(SUPPORTLIB)$(PATHSEP)." \
         $(PYTHON) misc/dependencies/build-deps-setup.py install \
	 --prefix="$(SUPPORT)"

EGGSPATH = $(shell $(PYTHON) misc/find-dep-eggs.py)
show-eggspath:
	@echo $(EGGSPATH)

PP=PYTHONPATH="$(SRCPATH)$(PATHSEP)$(EGGSPATH)$(PATHSEP)$(PYTHONPATH)$(OSSEP)."

.PHONY: make-version build
make-version:
	$(PYTHON) misc/make-version.py "allmydata-tahoe" "src/allmydata/_version.py"

.built:
	$(MAKE) build
	touch .built

build: make-version
	$(PYTHON) ./setup.py build_ext -i
	chmod +x bin/allmydata-tahoe

# 'make install' will do the following:
#   build+install tahoe (probably to /usr/lib/pythonN.N/site-packages)
# 'make install PREFIX=/usr/local/stow/tahoe-N.N' will do the same, but to
# a different location

install: make-version
ifdef PREFIX
	mkdir -p $(PREFIX)
	$(PP) $(PYTHON) ./setup.py install \
           --single-version-externally-managed \
           --prefix=$(PREFIX) --record=./tahoe.files
else
	$(PP) $(PYTHON) ./setup.py install \
           --single-version-externally-managed
endif


# TESTING

.PHONY: check-deps check-twisted-dep $(CHECK_PYWIN32_DEP) signal-error-deps, signal-error-twisted-dep, signal-error-pywin32-dep, test test-figleaf figleaf-output


signal-error-deps:
	@echo "ERROR: Not all of Tahoe's dependencies are in place.  Please\
see the README for help on installing dependencies."
	exit 1

signal-error-twisted-dep:
	@echo "ERROR: Before running \"make build-deps\" you have to ensure that\
Twisted is installed (including its zope.interface dependency).  Twisted and\
zope.interface are required for the automatic installation of certain other\
libraries that Tahoe requires).  Please see the README for details."
	exit 1

signal-error-pywin32-dep:
	@echo "ERROR: the pywin32 dependency is not in place.  Please see the README\
for help on installing dependencies."
	exit 1

check-deps: check-twisted-dep $(CHECK_PYWIN32_DEP)
	$(PP) \
	 $(PYTHON) -c 'import allmydata, zfec, foolscap, simplejson, nevow, OpenSSL' || $(MAKE) signal-error-deps

check-twisted-dep:
	$(PYTHON) -c 'import twisted, zope.interface' || $(MAKE) signal-error-twisted-dep

check-pywin32-dep:
	$(PYTHON) -c 'import win32process' || $(MAKE) signal-error-pywin32-dep

.checked-deps:
	$(MAKE) check-deps
	touch .checked-deps

# you can use 'make test TEST=allmydata.test.test_introducer' to run just
# test_introducer. TEST=allmydata.test.test_client.Basic.test_permute works
# too.
TEST=allmydata

# use 'make test REPORTER=--reporter=bwverbose' from buildbot, to
# suppress the ansi color sequences

test: .built .checked-deps
	$(PP) \
	 $(TRIAL) $(REPORTER) $(TEST)

test-figleaf: .built .checked-deps
	rm -f .figleaf
	$(PP) \
	 $(TRIAL) --reporter=bwverbose-figleaf $(TEST)

figleaf-output:
	$(PP) \
	 $(PYTHON) misc/figleaf2html -d coverage-html -r src -x misc/figleaf.excludes
	@echo "now point your browser at coverage-html/index.html"

# after doing test-figleaf and figleaf-output, point your browser at
# coverage-html/index.html

.PHONY: upload-figleaf .figleaf.el pyflakes count-lines
.PHONY: check-memory check-memory-once clean

# 'upload-figleaf' is meant to be run with an UPLOAD_TARGET=host:/dir setting
ifdef UPLOAD_TARGET

ifndef UPLOAD_HOST
$(error UPLOAD_HOST must be set when using UPLOAD_TARGET)
endif
ifndef COVERAGEDIR
$(error COVERAGEDIR must be set when using UPLOAD_TARGET)
endif

upload-figleaf:
	rsync -a coverage-html/ $(UPLOAD_TARGET)
	ssh $(UPLOAD_HOST) make update-tahoe-figleaf COVERAGEDIR=$(COVERAGEDIR)
else
upload-figleaf:
	echo "this target is meant to be run with UPLOAD_TARGET=host:/path/"
	/bin/false
endif

.figleaf.el: .figleaf
	$(PP) \
	 $(PYTHON) misc/figleaf2el.py .figleaf src

pyflakes:
	$(PYTHON) -OOu `which pyflakes` src/allmydata

count-lines:
	@echo -n "files: "
	@find src -name '*.py' |grep -v /build/ |wc --lines
	@echo -n "lines: "
	@cat `find src -name '*.py' |grep -v /build/` |wc --lines
	@echo -n "TODO: "
	@grep TODO `find src -name '*.py' |grep -v /build/` | wc --lines

check-memory: .built
	rm -rf _test_memory
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py upload
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py upload-self
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py upload-POST
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py download
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py download-GET
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py download-GET-slow
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py receive

check-memory-once: .built
	rm -rf _test_memory
	$(PP) \
	 $(PYTHON) src/allmydata/test/check_memory.py $(MODE)

# this target uses a pre-established client node to run a canned set of
# performance tests against a test network that is also pre-established
# (probably on a remote machine). Provide it with the path to a local
# directory where this client node has been created (and populated with the
# necessary FURLs of the test network). This target will start that client
# with the current code and then run the tests. Afterwards it will stop the
# client.
#
# The 'sleep 5' is in there to give the new client a chance to connect to its
# storageservers, since check_speed.py has no good way of doing that itself.

check-speed: .built
	if [ -z '$(TESTCLIENTDIR)' ]; then exit 1; fi
	$(PYTHON) bin/allmydata-tahoe start $(TESTCLIENTDIR)
	sleep 5
	$(PYTHON) src/allmydata/test/check_speed.py $(TESTCLIENTDIR)
	$(PYTHON) bin/allmydata-tahoe stop $(TESTCLIENTDIR)

test-darcs-boringfile:
	$(MAKE)
	$(PYTHON) misc/test-darcs-boringfile.py

test-clean:
	find . |grep -v allfiles.tmp |grep -v src/allmydata/_version.py |sort >allfiles.tmp.old
	$(MAKE)
	$(MAKE) clean
	find . |grep -v allfiles.tmp |grep -v src/allmydata/_version.py |sort >allfiles.tmp.new
	diff allfiles.tmp.old allfiles.tmp.new

clean:
	rm -rf build _trial_temp _test_memory .checked-deps .built
	rm -f debian
	rm -f `find src/allmydata -name '*.so' -or -name '*.pyc'`
	rm -rf tahoe_deps.egg-info allmydata_tahoe.egg-info
	rm -rf support dist
	rm -rf setuptools*.egg *.pyc



# DEBIAN PACKAGING

VER=$(shell $(PYTHON) misc/get-version.py)
DEBCOMMENTS="'make deb' build"

show-version:
	@echo $(VER)

.PHONY: setup-deb deb-ARCH is-known-debian-arch
.PHONY: deb-sid deb-feisty deb-edgy deb-etch

deb-sid:
	$(MAKE) deb-ARCH ARCH=sid
deb-feisty:
	$(MAKE) deb-ARCH ARCH=feisty
# edgy uses the feisty control files for now
deb-edgy:
	$(MAKE) deb-ARCH ARCH=edgy TAHOE_ARCH=feisty
# etch uses the feisty control files for now
deb-etch:
	$(MAKE) deb-ARCH ARCH=etch TAHOE_ARCH=feisty

# we know how to handle the following debian architectures
KNOWN_DEBIAN_ARCHES := sid feisty edgy etch

ifeq ($(findstring x-$(ARCH)-x,$(foreach arch,$(KNOWN_DEBIAN_ARCHES),"x-$(arch)-x")),)
is-known-debian-arch:
	@echo "ARCH must be set when using setup-deb or deb-ARCH"
	@echo "I know how to handle:" $(KNOWN_DEBIAN_ARCHES)
	/bin/false
else
is-known-debian-arch:
	/bin/true
endif

ifndef TAHOE_ARCH
TAHOE_ARCH=$(ARCH)
endif

setup-deb: is-known-debian-arch
	rm -f debian
	ln -s misc/$(TAHOE_ARCH)/debian debian
	chmod +x debian/rules

# etch (current debian stable) has python-simplejson-1.3, which doesn't 
#  support indent=
# sid (debian unstable) currently has python-simplejson 1.7.1
# edgy has 1.3, which doesn't support indent=
# feisty has 1.4, which supports indent= but emits a deprecation warning
# gutsy has 1.7.1
#
# we need 1.4 or newer

deb-ARCH: is-known-debian-arch setup-deb
	fakeroot debian/rules binary
	echo
	echo "The newly built .deb packages are in the parent directory from here."

.PHONY: increment-deb-version
.PHONY: deb-sid-head deb-edgy-head deb-feisty-head
.PHONY: deb-etch-head

# The buildbot runs the following targets after each change, to produce
# up-to-date tahoe .debs. These steps do not create .debs for anything else.

increment-deb-version: make-version
	debchange --newversion $(VER) $(DEBCOMMENTS)
deb-sid-head:
	$(MAKE) setup-deb ARCH=sid
	$(MAKE) increment-deb-version
	fakeroot debian/rules binary
deb-edgy-head:
	$(MAKE) setup-deb ARCH=edgy TAHOE_ARCH=feisty
	$(MAKE) increment-deb-version
	fakeroot debian/rules binary
deb-feisty-head:
	$(MAKE) setup-deb ARCH=feisty
	$(MAKE) increment-deb-version
	fakeroot debian/rules binary
deb-etch-head:
	$(MAKE) setup-deb ARCH=etch TAHOE_ARCH=feisty
	$(MAKE) increment-deb-version
	fakeroot debian/rules binary

=== misc/dapper/debian/changelog ===
foolscap (0.1.6) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Sat, 01 Sep 2007 23:58:54 -0700

foolscap (0.1.5) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Tue, 07 Aug 2007 17:47:53 -0700

foolscap (0.1.4) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Mon, 14 May 2007 22:37:04 -0700

foolscap (0.1.3) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Wed,  2 May 2007 14:55:49 -0700

foolscap (0.1.2) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Wed,  4 Apr 2007 12:32:46 -0700

foolscap (0.1.1) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Tue,  3 Apr 2007 20:48:07 -0700

foolscap (0.1.0) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Thu, 15 Mar 2007 16:56:16 -0700

foolscap (0.0.7) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Tue, 16 Jan 2007 12:03:00 -0800

foolscap (0.0.6) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Mon, 18 Dec 2006 12:10:51 -0800

foolscap (0.0.5) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Sat,  4 Nov 2006 23:20:46 -0800

foolscap (0.0.4) unstable; urgency=low

  * new release

 -- Brian Warner <warner@lothar.com>  Thu, 26 Oct 2006 00:46:30 -0700

foolscap (0.0.3) unstable; urgency=low

  * new upstream release, put debian packaging in the tree

 -- Brian Warner <warner@lothar.com>  Tue, 10 Oct 2006 19:16:13 -0700

foolscap (0.0.2) unstable; urgency=low

  * New upstream release of an experimental package

 -- Brian Warner <warner@lothar.com>  Thu, 27 Jul 2006 17:40:15 -0700

=== misc/feisty/debian/control ===
Source: allmydata-tahoe
Section: python
Priority: optional
Maintainer: Brian Warner <warner@allmydata.com>
Build-Depends: debhelper (>= 5.0.37.1), cdbs (>= 0.4.41), python-central (>= 0.4.10), python, python-all-dev
Build-Depends-Indep: python-twisted
XS-Python-Version: 2.4,2.5
Standards-Version: 3.7.2

Package: allmydata-tahoe
Architecture: all
Depends: ${python:Depends}, python-twisted, python-foolscap, python-pyopenssl, python-nevow, python-simplejson, python-zfec
Recommends:
XB-Python-Version: 2.4,2.5
Description: A secure distributed filestore
 Allmydata (tahoe2)

=== misc/sid/debian/control ===
Source: allmydata-tahoe
Section: python
Priority: optional
Maintainer: Brian Warner <warner@allmydata.com>
Build-Depends: debhelper (>= 5.0.37.2), cdbs (>= 0.4.43), python-central (>= 0.5), python, python-dev
Build-Depends-Indep: python-twisted-core
XS-Python-Version: 2.4
Standards-Version: 3.7.2

Package: allmydata-tahoe
Architecture: all
Depends: ${python:Depends}, python-twisted-core, python-foolscap, python-pyopenssl, python-twisted-names, python-nevow, python-simplejson, python-zfec
Recommends:
XB-Python-Version: 2.4
Description: A secure distributed filestore
 Allmydata (tahoe2)

=== misc/feisty/debian/rules ===
#! /usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_PYTHON_SYSTEM=pycentral

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk

STAGING_DIR=$(CURDIR)/debian/allmydata-tahoe

install/allmydata-tahoe::
	mkdir -pm755 $(STAGING_DIR)
	python setup.py install --root=$(STAGING_DIR)

	dh_pycentral

clean::
	-rm -rf build

=== misc/sid/debian/rules ===
#! /usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_PYTHON_SYSTEM=pycentral

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-distutils.mk

PREFIX=$(shell pwd)/debian/allmydata-tahoe/usr

build/allmydata-tahoe::
	python2.4 setup.py install --prefix=$(PREFIX)

clean::
	-rm -rf build
